#include <reg1210.h>
#include <stdio.h>

//define DISABLE_SIMPLE_SER

#ifndef DISABLE_SIMPLE_SER

int simple_ser_init(void)
{
  ES0=0;
  SCON0=0x50;
  PCON|=0x80;	/* Bd = OSC/12/16/(256-TH1) */

 #if 1
  RCLK=0;	/* Timer 1 for serial 0 receiver */
  TCLK=0;	/* Timer 1 for serial 0 transmitter */
  CKCON&=~0x10;	/* T1M = 0 => timer 1 clock is f/12 else f/4 */
 #endif
  TR1=0;
  TH1=-5;
  /*TH1=-3;*/
  TMOD&=0x0F;
  TMOD|=0x20;
  TR1=1;
  TI=1;
  return 0;
}

char getchar() {
  char c;
  while (!RI)
    ;
  RI=0;
  c=SBUF;
  return c;
}

char putchar(char c) {
  while (!TI)
    ;
  TI=0;
  SBUF=c;
  if (c=='\n') {
    putchar('\r');
  }
  return c;
}

#else /* DISABLE_SIMPLE_SER */

int simple_ser_init(void)
{
  return 0;
}

char getchar() {
  return 0;
}

char putchar(char c) {
  return c;
}


#endif /* DISABLE_SIMPLE_SER */
