//**************************************************************************
//                                   Petr Smolik
//**************************************************************************

#if !defined(__ulan_h)
#define __ulan_h

#include <AT89X52.H>

#define SWAPWORD(x)   ( (((x) << 8) & 0xFF00) | (((x) >> 8) & 0x00FF) )

extern uL_FNC(),uL_FNCC(unsigned char value),uL_INIT();
extern uL_STR();
extern bit uLF_ERR,uLF_INE,uLF_KMP,uLF_RS,uLF_NB,uLF_NA;
extern unsigned char xdata uL_ISAD,uL_IDAD,uL_ICOM,uL_IST,uL_ISTA;
extern unsigned xdata uL_ILEN;

typedef struct ul_msginfo {
	unsigned char dadr;		/* destignation address */
	unsigned char sadr;		/* source address */
	unsigned char cmd;		/* command/socket number */
	unsigned char flg;		/* message flags */
	unsigned char stamp;		/* stamp */
} ul_msginfo;

//*****************************************************************************
// Status zprav
#define uLBF_FAIL         0x008         // Message cannot be send - error
#define uLBF_PROC         0x004         // Message succesfull send
#define uLBF_AAP          0x003         // Request imediate proccessing of frame by receiver station with acknowledge
#define uLBF_PRQ          0x002         // Request imediate proccessing of frame by receiver station
#define uLBF_ARQ          0x001         // Request imediate acknowledge by receiving station


//*****************************************************************************
void uLanInit(unsigned char adr,unsigned char bauderate) {
  ACC=bauderate;
  uL_FNCC(0x01);       // Prenosova rychlost
  ACC=adr;
  uL_FNCC(0x02);       // Nastaveni adresy
  uL_INIT();           // Inicializace
}

//*****************************************************************************
bit uLanSndMsg(ul_msginfo *msginfo,unsigned char *pmsg,unsigned len) {
  F0=0;                 // nulovani chyby
  uL_ISAD=(msginfo->sadr & 0x7F);// sadr
  uL_IST=msginfo->flg;  // status zpravy
  uL_IDAD=(msginfo->dadr & 0x7F);// dadr
  uL_ICOM=msginfo->cmd; // cmd
  uL_ISTA=msginfo->stamp;// stamp
  uL_FNCC(0x10);        // Otevreni vystupni zpravy
  uL_ILEN=SWAPWORD(len);// length
  DPH=(unsigned)pmsg/256;DPL=(unsigned)pmsg%256; //DP adresa
  uL_FNCC(0x11);        // Data zpravy v RAM
  uL_FNCC(0x12);        // Zapsani zpravy
  return F0;
}

//*****************************************************************************
int uLanRcvMsg(ul_msginfo *msginfo,unsigned char *pmsg,unsigned max_len) {
  F0=0;                // nulovani chyby
  uL_FNCC(0x20);       // Otevreni vstupni zpravy
  msginfo->dadr=(uL_IDAD & 0x7F);// dadr
  msginfo->flg=uL_IST; // status zpravy
  msginfo->sadr=(uL_ISAD & 0x7F);// sadr
  msginfo->cmd=uL_ICOM;// cmd
  msginfo->stamp=uL_ISTA; // stamp
  if (F0) {            // je zprava ? ->ne
    F0=0;              // nastaveni priznaku snulovani chyby
    uL_FNCC(0x22);     // Uzavreni zpravy
    uLF_INE=0;
    return -1;
  }
  uL_ILEN=SWAPWORD(max_len);// length
  DPH=(unsigned)pmsg/256;DPL=(unsigned)pmsg%256; //DP adresa
  uL_FNCC(0x21);        // Data zpravy v RAM
  F0=0;                // nastaveni priznaku snulovani chyby
  uL_FNCC(0x22);       // Uzavreni zpravy
  return max_len-SWAPWORD(uL_ILEN)-1;
}

#endif
