/*****************************************************/
/***   Module : Main module                        ***/
/***   Author : Roman Bartosinski (C) 28.04.2002   ***/
/***   Modify : 15.09.2002                         ***/
/*****************************************************/

  #include "hal.h"
  #include "stdio_d.h"
  #include "serial.h"
#ifdef COMMANDS_PLUGIN
  #include "commands.h"
#endif
  #include "pdiusb.h"
  #include "usb.h"
  #include "main.h"


  appl_flags_t pflags;

/*** inicializace globalnich promennych a jednotlivych casti ***/
  _sdcc_external_startup() {
    EA = 0;
    IE = 0;
#ifdef START_WITH_USB
    USBDisconnect();
#endif
    LEDr = 1; LEDg = 1;
    pflags.Echo=0; /* start with echo (serial line) */
    pflags.Debug=0; /* start with debug mode */
    pflags.Command = pflags.CommandExec = 0;
    InitSerial();
    InitUSB();
#ifdef COMMANDS_PLUGIN
    clear_command_line();
#endif
    EA=1;
#ifdef START_WITH_USB
    printf( "USB on\n");
    USBConnect();
#endif
    LEDg = 0; LEDr = 0;
    printf( "Initiated\n");
    /*return 0; => __sdcc_init_data should be processed */
    return 1; /* => __sdcc_init_data is skipped */
  }


/* other endpoints buffer */
  #define GENBUFSIZE 64
  xdata unsigned char GenEpBuffer[GENBUFSIZE];
  xdata unsigned char Readed;

  
/********************
 *** MAIN program ***
 ********************/
  void main( void) {
    /* enable serial input/output */
    sflags.Output = 1; sflags.Input = 1;
    
    cmd_ver_fnc();

    while ( 1) {
/* USB */
      if(!pdiIRQ){
        /*putchar('I');*/
        UsbInterrupt();
      }
      execute_usb_request();
      if (uflags.Ep1RxInt) { 
        Readed = pdiReadEndpoint( PDI_EP1_RX, GENBUFSIZE, GenEpBuffer); 
        uflags.Ep1RxInt=0;
      }
      if (uflags.Ep1TxInt) { 
        uflags.Ep1TxInt=0;
      }
      if (uflags.Ep2RxInt) { 
        Readed = pdiReadEndpoint( PDI_EP2_RX, GENBUFSIZE, GenEpBuffer); 
        uflags.Ep2RxInt=0;
      }
      if (uflags.Ep2TxInt) { 
        uflags.Ep2TxInt=0;
      }

/* commands from serial */
    #ifdef COMMANDS_PLUGIN
      if ( pflags.Command) {
        execute_command();
      }
    #endif

    }
  }

// end of file :)
