/*****************************************************************/
/***   Module : Serial communication functions - header file   ***/
/***   Author : Roman Bartosinski (C) 28.04.2002               ***/
/***   Modify : 27.08.2002                                     ***/
/*****************************************************************/

#ifndef _SERIAL_MODULE
  #define _SERIAL_MODULE

  #define SER_SBLEN 128
  #define SER_RBLEN 32

  typedef unsigned char SerialCnt_t;
  //typedef unsigned int SerialCnt_t;

  extern xdata volatile SerialCnt_t srCnt, ssCnt, srPos, ssPos;
  extern xdata volatile unsigned char srBuf[SER_RBLEN], ssBuf[SER_SBLEN];
  
  extern xdata volatile unsigned long baudrate;

/* serial transfer input/output flags */
  typedef struct serial_flags {
    unsigned char Output:1;   /* output is to rs232 */
    unsigned char Input:1;    /* input is from rs232 */
    unsigned char Busy:1;     /* char is sending by rs232 now */
    unsigned char Terminal:1; /* rs232 as terminal */
  } serial_flags_t;

  extern serial_flags_t sflags;

/* serial interrupt handler - has been _naked, tested using 3 */
  void SerialInterrupt( void) interrupt;
/* init serial link */
  void InitSerial( void);
/* set baud rates */
  unsigned char SerialSetBaudRate( unsigned short NewBaud);
/* common chars functions */
  void ser_putc( unsigned char c) reentrant;
  unsigned char ser_getc();

#endif
