/*****************************************************/
/***   Module : modified standard stdio library    ***/
/***   Author : Roman Bartosinski (C) 28.04.2002   ***/
/***   Modify : 08.08.2002                         ***/
/***   Modify   05.09.2002 - reduce to FU          ***/
/*****************************************************/

#include "hal.h"
#include "stdio_d.h"

#include "serial.h" // !!!

  xdata PRINTF vData;

bit add_cr_fl;

// putchar
  void putchar( unsigned char chr) {
    if ( sflags.Output){
      if (( chr == '\n') && !add_cr_fl) // transform '\n' -> '\r\n'
        putchar( '\r');
      add_cr_fl = (chr == '\r');
      ser_putc( chr);
    }
  }

  void showBits( unsigned char mybyte) {
    register unsigned char i=0x80;
    while( i) {
      if ( mybyte & i)
        putchar( '1');
      else
        putchar( '0');
      i >>= 1;
    }
  }
  void WriteBin( unsigned int num) {
    if ( num & 0xff00)
      showBits((char)( num >> 8));
    showBits((char) num);
  }

  void WriteHexLarge( unsigned int num) {
    unsigned char i, j;
//    high -= 10;
    if ( num & 0xff00)
      j = 4;
    else {
      j = 2; num = num << 8;
    }
    while( j--) {
      i = (num & 0xf000) >> 12;
      if ( i > 0x09) 
//        putchar( i + high); 
        putchar( i + 'A' - 10); 
      else 
        putchar( i + '0');
      num = num << 4;
    } 
  }

  char help_put_dec_char( unsigned char chr) {
    if ((( chr & 0x7f) > '0') || ( chr & 0x80)) { 
      putchar( chr & 0x7f); return 0x80;
    } else
      return 0;
  }
  void WriteDec( int num) {
    unsigned char chr; // ve spodnbich 7 bitech je znak pro zobrazeni, horni bit(0x80)
                       // je znacka,ze se maji nuly zobrazit(aby nebylo napr 0056)
    if ( num == 0) {
      putchar('0'); return;
    }
    if ( num < 0) {
      putchar('-'); num = -num;
    }
    chr = '0';
    while ( num >= 10000) { chr++; num -= 10000; }
    chr = help_put_dec_char( chr) + '0'; 
    while ( num >= 1000) { chr++; num -= 1000; }
    chr = help_put_dec_char( chr) + '0';
    while ( num >= 100) { chr++; num -= 100; }
    chr = help_put_dec_char( chr) + '0';
    while ( num >= 10) { chr++; num -= 10; }
    chr = help_put_dec_char( chr) + '0';
    while ( num) { chr++; num--; }
    putchar( chr & 0x7f);
  }

  void WriteText( void) {
    register unsigned char cnt = 0;
    unsigned char *str = vData.Str;
    while ( *str) {
      if ( *str == '%') {
        str++;
        switch ( *str) {
          case 'c': putchar((char) vData.Par[cnt++]);
                    break;
          case 'd': WriteDec((int) vData.Par[cnt++]);
                    break;
          case 'X': WriteHexLarge((unsigned int) vData.Par[cnt++]);
                    break;
          case 'b': WriteBin((unsigned int) vData.Par[cnt++]);
                    break;
          case 's': {
                      xdata unsigned char *str1 = vData.Par[cnt++];
                      while ( *str1) {
                        putchar( *str1++);
                      }
                    }                    
                    break;
          case '%': putchar( '%');
                    break;
        }
      } else
        putchar( *str);
      str++;
    }
  }


  unsigned char chstrlen( char * str) {
    unsigned char j = 0;
    while ( *(str++))
      j++;
    return j;
  }
