#!/bin/bash

FILENAME=ulan

if [ $# -gt 0 ] ; then
  FILENAME=`basename "$1" .asm`
fi

if true ; then
cat ${FILENAME}.asm | strip0d | \
tr '[A-Z]' '[a-z]' | \
sed -e 's/^[[:blank:]]*\$include[[:blank:]]*(\(.*\))/.include "\1"/g' | \
sed -e 's/^[[:blank:]]*%define[[:blank:]]*(\(.*\))[[:blank:]]*(\(.*\))/\1 = \2/g' | \
sed -e 's/[[:blank:]]*%if[[:blank:]]*([[:blank:]]*not[[:blank:]]*\(.*\))[[:blank:]]*then[[:blank:]]*(/.if 1^\1/g' | \
sed -e 's/[[:blank:]]*%if[[:blank:]]*(\(.*\))[[:blank:]]*then[[:blank:]]*(/.if \1/g' | \
sed -e 's/[[:blank:]]*)[[:blank:]]*fi/.endif /g' | \
sed -e 's/[[:blank:]]*)[[:blank:]]*else[[:blank:]]*(/.else /g' | \
sed -e 's/\(..*\)\(.endif\|.else\)/\1\
\2/g' | \
sed -e 's/\<equ\>/=/g' | \
sed -e "s/\<db[[:blank:]]*'\([^']*\)',0\>/.asciz '\1'/g" | \
sed -e 's/\<\(db\|ds\|dw\)\>/.\1/g' | \
sed -e 's/\<public\>/.globl/g' | \
sed -e 's/\<extrn\>[[:blank:]]*\([[:alpha:]]*\)[[:blank:]]*(\(.*\))/.globl \2 ; \1/g' | \
sed -e 's/%//g' | \
sed -e 's/\<\([0-9][0-9A-Fa-f]*\)[Hh]\>/0x\1/g' | \
sed -e 's/\<\([0-1]*\)[Bb]\>/0b\1/g' | \
sed -e 's/^[^;]*\<segment\>/;\0/g' | \
sed -e 's/^\([^;]*\)\<call\>/\1lcall/g' | \
sed -e 's/^\([^;]*\)\<jmp\>/\1ljmp/g' | \
sed -e 's/^\([^;]*\)\<end\>/\1/g' | \
sed -e 's/^\([^;]*\)\<low\>/\1</g' | \
sed -e 's/^\([^;]*\)\<high\>/\1>/g' | \
sed -e 's/^\([^;]*\)\<and\>/\1\&/g' | \
sed -e 's/^\([^;]*\)\<or\>/\1|/g' | \
sed -e 's/^\([^;]*\)\<xor\>/\1^/g' | \
sed -e 's/^\([^;]*\)\<not\>/\1~/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\([[:alnum:]_]*_c\)/.area CSEG (CODE) ;\1/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\([[:alnum:]_]*_x\)/.area XSEG (XDATA);\1/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\([[:alnum:]_]*_d\)/.area DSEG (DATA) ;\1/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\([[:alnum:]_]*_i\)/.area ISEG (DATA) ;\1/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\([[:alnum:]_]*_b\)/.area UL_BSEG (ABS,DATA,CON)  ;\1\
.org 0x20\
ul_bseg_s:\
.org 0x24/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\(ser_stack\)/.area DSEG (DATA) \
\1:/g' | \
sed -e 's/^[[:blank:]]*rseg[[:blank:]]*\([[:alnum:]_]*\)/.area \1/g' | \
sed -e 's/^[[:blank:]]*\([[:alnum:]_]*\)[[:blank:]]*\(xdata\|data\|idata\|code\)[[:blank:]]*\([[:alnum:]_]*\)/\1=\3 ;\2 /g' | \
sed -e 's/^[[:blank:]]*\([[:alnum:]_]*\)[[:blank:]]*bit[[:blank:]]*\(ul_fl[[:alnum:]_]*\)\.\([0-7]\)/\1=((\2-ul_bseg_s)*8)+\3 /g' | \
sed -e 's/^[[:blank:]]*\([[:alnum:]_]*\)[[:blank:]]*bit[[:blank:]]*\([[:alnum:]_.]*\)/\1=\2 /g' | \
sed -e 's/\<cseg[[:blank:]]*at\>/.area CSEG_A (ABS,CODE)\
.org/g' | \
sed -e 's/\<xseg[[:blank:]]*at\>/.area XSEG_A (ABS,XDATA)\
.org/g' | \
sed -e 's/\<dseg[[:blank:]]*at\>/.area DSEG_A (ABS,DATA)\
.org/g' | \
sed -e 's/^[[:blank:]]*using[[:blank:]]*\([0-3]\)/; switch to bank \1 \
ar0=0+8*\1 \
ar1=1+8*\1 \
ar2=2+8*\1 \
ar3=3+8*\1 \
ar4=4+8*\1 \
ar5=5+8*\1 \
ar6=6+8*\1 \
ar7=7+8*\1 \
/g' | \
sed -e 's/\$nomod51//g' | \
sed -e 's/^for_sdcc = 0/for_sdcc = 1/g' | \
sed -e 's/\<s_gsinit\>/s_GSINIT/g' | \
cat >${FILENAME}.s
#tee ${FILENAME}.s
fi

#
if false ; then 
echo 'A OR B' | \
sed -e 's/\<OR\>/|/g' | \
cat
fi

#sed -e 's/^[[:blank:]]*\([[:alnum:]_]*\)[[:blank:]]*bit[[:blank:]]*\([[:alnum:]_.]*\)/\1=\2 /g' | \
#sed -e 's/^[[:blank:]]*\([[:alnum:]_]*\)[[:blank:]]*bit[[:blank:]]*\(ul_fl[[:alnum:]_]*\)\.\([0-7]\)/\1=((\2-ul_flg)*8)+\3 /g' | \
