// Texas Instruments
// Name:	Reg1210.h
// Revision: 	1.0
// Description: Header file for TI MSC1210 microcontroller

/*  BYTE Registers  */
sfr at 0x80 P0;
sfr at 0x81 SP;
sfr at 0x82 DPL;
sfr at 0x83 DPH;
sfr at 0x82 DPL0;
sfr at 0x83 DPH0;
sfr at 0x84 DPL1;
sfr at 0x85 DPH1;
sfr at 0x86 DPS;
sfr at 0x87 PCON;
sfr at 0x88 TCON;
  sbit at 0x88+7 TF1;
  sbit at 0x88+6 TR1;
  sbit at 0x88+5 TF0;
  sbit at 0x88+4 TR0;
  sbit at 0x88+3 IE1;
  sbit at 0x88+2 IT1;
  sbit at 0x88+1 IE0;
  sbit at 0x88+0 IT0;
sfr at 0x89 TMOD;
sfr at 0x8A TL0;
sfr at 0x8B TL1;
sfr at 0x8C TH0;
sfr at 0x8D TH1;
sfr at 0x8E CKCON;
sfr at 0x8F MWS;
sfr at 0x90 P1;
  sbit at 0x90+7 INT5; 
  sbit at 0x90+7 SCK; 
  sbit at 0x90+6 INT4; 
  sbit at 0x90+6 MISO; 
  sbit at 0x90+5 INT3; 
  sbit at 0x90+5 MOSI; 
  sbit at 0x90+4 INT2; 
  sbit at 0x90+4 SS; 
  sbit at 0x90+3 TXD1; 
  sbit at 0x90+2 RXD1; 
  sbit at 0x90+1 T2EX; 
  sbit at 0x90+0 T2;
sfr at 0x91 EXIF;
sfr at 0x92 MPAGE;
sfr at 0x93 CADDR;
sfr at 0x94 CDATA;
sfr at 0x95 MCON;
sfr at 0x98 SCON;
sfr at 0x98 SCON0;
  sbit at 0x98+7 SM0_0;
  sbit at 0x98+6 SM1_0;
  sbit at 0x98+5 SM2_0;
  sbit at 0x98+4 REN_0;
  sbit at 0x98+3 TB8_0;
  sbit at 0x98+2 RB8_0;
  sbit at 0x98+1 TI_0;
  sbit at 0x98+1 TI;
  sbit at 0x98+0 RI_0;
  sbit at 0x98+0 RI;
sfr at 0x99 SBUF;
sfr at 0x99 SBUF0;
sfr at 0x9A SPICON;
sfr at 0x9B SPIDATA;
sfr at 0x9C SPIRCON;
sfr at 0x9D SPITCON;
sfr at 0x9E SPISTRT;
sfr at 0x9F SPIEND;
sfr at 0xA0 P2;
sfr at 0xA1 PWMCON;
sfr at 0xA2 PWMLOW;
sfr at 0xA3 PWMHI;
sfr at 0xA5 PAI;
sfr at 0xA6 AIE;
sfr at 0xA7 AISTAT;
sfr at 0xA8 IE;
  sbit at 0xA8+7 EA;
  sbit at 0xA8+6 ES1;
  sbit at 0xA8+5 ET2;
  sbit at 0xA8+4 ES0;
  sbit at 0xA8+3 ET1;
  sbit at 0xA8+2 EX1;
  sbit at 0xA8+1 ET0;
  sbit at 0xA8+0 EX0;
sfr at 0xA9 BPCON;
sfr at 0xAA BPL;
sfr at 0xAB BPH;
sfr at 0xAC P0DDRL;
sfr at 0xAD P0DDRH;
sfr at 0xAE P1DDRL;
sfr at 0xAF P1DDRH;
sfr at 0xB0 P3;
  sbit at 0xB0+7 RD;
  sbit at 0xB0+6 WR;
  sbit at 0xB0+5 T1;
  sbit at 0xB0+4 T0;
  sbit at 0xB0+3 INT1;
  sbit at 0xB0+2 INT0;
  sbit at 0xB0+1 TXD;
  sbit at 0xB0+1 TXD0;
  sbit at 0xB0+0 RXD;
  sbit at 0xB0+0 RXD0;
sfr at 0xB1 P2DDRL;
sfr at 0xB2 P2DDRH;
sfr at 0xB3 P3DDRL;
sfr at 0xB4 P3DDRH;
sfr at 0xB8 IP;
  sbit at 0xB8+6 PS1;
  sbit at 0xB8+5 PT2;
  sbit at 0xB8+4 PS;
  sbit at 0xB8+4 PS0;
  sbit at 0xB8+3 PT1;
  sbit at 0xB8+2 PX1;
  sbit at 0xB8+1 PT0;
  sbit at 0xB8+0 PX0;
sfr at 0xC0 SCON1;
  sbit at 0xc0+7 SM0_1;
  sbit at 0xc0+6 SM1_1;
  sbit at 0xc0+5 SM2_1;
  sbit at 0xc0+4 REN_1;
  sbit at 0xc0+3 TB8_1;
  sbit at 0xc0+2 RB8_1;
  sbit at 0xc0+1 TI_1;
  sbit at 0xc0+0 RI_1;
sfr at 0xC1 SBUF1;
sfr at 0xC6 EWU;
sfr at 0xC8 T2CON;
  sbit at 0xC8+7 TF2;
  sbit at 0xC8+6 EXF2;
  sbit at 0xC8+5 RCLK;
  sbit at 0xC8+4 TCLK;
  sbit at 0xC8+3 EXEN2;
  sbit at 0xC8+2 TR2;
  sbit at 0xC8+1 C_T2;
  sbit at 0xC8+0 CP_RL2;
sfr at 0xCA RCAP2L;
sfr at 0xCB RCAP2H;
sfr at 0xCC TL2;
sfr at 0xCD TH2;
sfr at 0xD0 PSW;
  sbit at 0xD0+7 CY;
  sbit at 0xD0+6 AC;
  sbit at 0xD0+5 F0;
  sbit at 0xD0+4 RS1;
  sbit at 0xD0+3 RS0;
  sbit at 0xD0+2 OV;
  sbit at 0xD0+1 F1;
  sbit at 0xD0+0 P;
sfr at 0xD1 OCL;
sfr at 0xD2 OCM;
sfr at 0xD3 OCH;
sfr at 0xD4 GCL;
sfr at 0xD5 GCM;
sfr at 0xD6 GCH;
sfr at 0xD7 ADMUX;
sfr at 0xD8 EICON;
  sbit at 0xD8+7 SMOD1;
  sbit at 0xD8+5 EAI;
  sbit at 0xD8+4 AI;
  sbit at 0xD8+3 WDTI;
sfr at 0xD9 ADRESL;
sfr at 0xDA ADRESM;
sfr at 0xDB ADRESH;
sfr at 0xDC ADCON0;
sfr at 0xDD ADCON1;
sfr at 0xDE ADCON2;
sfr at 0xDF ADCON3;
sfr at 0xE0 ACC;
sfr at 0xE1 SSCON;
sfr at 0xE2 SUMR0;
sfr at 0xE3 SUMR1;
sfr at 0xE4 SUMR2;
sfr at 0xE5 SUMR3;
sfr at 0xE6 ODAC;
sfr at 0xE7 LVDCON;
sfr at 0xE8 EIE;
  sbit at 0xE8+4 EWDI;
  sbit at 0xE8+3 EX5;
  sbit at 0xE8+2 EX4;
  sbit at 0xE8+1 EX3;
  sbit at 0xE8+0 EX2;
sfr at 0xE9 HWPC0;
sfr at 0xEA HWPC1;
sfr at 0xEB HWID;
sfr at 0xEE FMCON;
sfr at 0xEF FTCON;
sfr at 0xF0 B;
sfr at 0xF1 PDCON;
sfr at 0xF2 PASEL;
sfr at 0xF6 ACLK;
sfr at 0xF7 SRST;
sfr at 0xF8 EIP;
  sbit at 0xF8+4 PWDI;
  sbit at 0xF8+3 PX5;
  sbit at 0xF8+2 PX4;
  sbit at 0xF8+1 PX3;
  sbit at 0xF8+0 PX2;
sfr at 0xF9 SECINT;
sfr at 0xFA MSINT;
sfr at 0xFB USEC;
sfr at 0xFC MSECL;
sfr at 0xFD MSECH;
sfr at 0xFE HMSEC;
sfr at 0xFF WDTCON;

/*-----------------*/
/*  Word Registers  */
/*-----------------*/
#if 0
sfr16 at 0xde DECIMATION;
sfr16 at 0xcc THL2;
sfr16 at 0xca RCAP2;
sfr16 at 0xfc ONEMS;
sfr16 at 0xa2 PWM;
sfr16 at 0xac P0DDR;
sfr16 at 0xae P1DDR;
sfr16 at 0xb1 P2DDR;
sfr16 at 0xb3 P3DDR;
sfr16 at 0xaa BRKPT;
#else
sfr at 0xde DECIMATIONL;
sfr at 0xdf DECIMATIONH;
sfr at 0xfc ONEMSL;
sfr at 0xfd ONEMSH;
sfr at 0xa2 PWML;
sfr at 0xa3 PWMH;
sfr at 0xaa BRKPTH;
sfr at 0xab BRKPTL;
#endif
