/*#include <8052.h>*/
#include "reg1210.h"
#include "stdio.h"
#include "ulan.h"
#include "ul_util.h"
#include "string.h"

//volatile sbit at 0xB3 LED1;        // P3.3
sbit LED1 = 0xB3;        // P3.3

bit My_Bit;

unsigned char _sdcc_external_startup( void) {
  EA = 0;
  LED1=0;
  #ifndef SDCC
  #pragma asm
	extrn code(?C_START)
	mov sp,#0C0h
	jmp ?C_START
  #pragma endasm
  #endif
  return 0;
}

#if 0
data  char ad, *pd;
xdata char ax, *px;
code  char ac=0, *pc;

char *p1, *p2, *p3;
long l1, l2, l3;
long i1, i2, i3;

int f()
{

  p1=&ad; p2=&ax; p3=&ac;

  l1=(long)&ad; l2=(long)(char*)&ax; l3=(long)&ac;

  i1=(int)&ad; i2=(int)&ax; i3=(int)&ac;

  return 0;
}

data ul_msginfo mi_d;
xdata ul_msginfo mi_x;
code ul_msginfo mi_c={0,};
volatile char vc;

static int ul_msg(ul_msginfo *mi)
{
  if((unsigned char)((unsigned long)mi>>16)==0x1){
    vc=1;
  }
  return 0;
}

int f2()
{
  ul_msg(&mi_d);
  ul_msg(&mi_x);
  ul_msg(&mi_c);
  return 0;
}

void call_s_int(void)
{
  _asm
	.globl s_int
	lcall s_int
	/*lcall 0x0023*/
  _endasm;
}
#endif

void deb_wait(int delay)
{
  volatile int waste;
  while(delay--){
    for(waste=20;waste--;);
  }
}

void test_rec(void)
{
  RI=0;
  LED1=RB8_1;
  if(RB8_1){
    if(SBUF1==5){
      LED1=1;
    }
  }
}

int ser0_init(void)
{
  ES0=0;
  SCON0=0x50;
  PCON|=0x80;	/* Bd = OSC/12/16/(256-TH1) */

  RCLK=0;	/* Timer 1 for serial 0 receiver */
  TCLK=0;	/* Timer 1 for serial 0 transmitter */
  CKCON&=~0x10;	/* T1M = 0 => timer 1 clock is f/12 else f/4 */
  TR1=0;
  TH1=-5;
  TMOD&=0x0F;
  TMOD|=0x20;
  TR1=1;
  TI=1;
  return 0;
}

void regtest(void)
{
  #ifdef SDCC
  _asm
	mov  a,#0xaa
	mov  b,#0xbb
	mov  r0,#0xc0
	mov  r1,#0xc1
	mov  r2,#0xc2
	mov  r3,#0xc3
	mov  r4,#0xc4
	mov  r5,#0xc5
	mov  r6,#0xc6
	mov  r7,#0xc7
	mov  dptr,#0xd1d2
00005$:
	jnb  _RI,00005$
  _endasm;
  #else /*SDCC*/
  #pragma asm
	mov  a,#0aah
	mov  b,#0bbh
	mov  r0,#0c0h
	mov  r1,#0c1h
	mov  r2,#0c2h
	mov  r3,#0c3h
	mov  r4,#0c4h
	mov  r5,#0c5h
	mov  r6,#0c6h
	mov  r7,#0c7h
	mov  dptr,#0d1d2h
regtest_l1:
	jnb  RI,regtest_l1
  #pragma endasm
  #endif /*SDCC*/
}


int xdata_test(unsigned start, unsigned stop)
{
  *(volatile unsigned xdata*)start=0x5aa5;
  if(*(volatile unsigned xdata*)start!=0x5aa5) return -2;
  if(*(volatile unsigned code*)start!=0x5aa5) return -3;
  return 0;
}  

int xdata_test1(unsigned start, unsigned stop)
{
  unsigned char xdata *p;
  unsigned char code *r;
  unsigned u;
  int ret;
  unsigned addr;
  ret=0;
  
  for(u=0x55AA, p=(char xdata*)start;p<(char xdata*)stop;){
    *(p++)=u;
    *(p++)=u>>8;
    u=(u<<1)^(u>>8);
  }

  for(u=0x55AA, r=(char code*)start; r<(char code*)stop;){
    if(*(r++)!=(u&0xff)) {addr=(long)(r-1); ret=-3; break; }
    if(*(r++)!=((u>>8)&0xff)) {addr=(long)(r-1); ret=-3; break; }
    u=(u<<1)^(u>>8);
  }

  for(u=0x55AA, p=(char xdata*)start; p<(char xdata*)stop;){
    if(*(p++)!=(u&0xff)) {addr=(long)(p-1); ret=-2; break;}
    if(*(p++)!=((u>>8)&&0xff)) {addr=(long)(p-1); ret=-2; break;}
    u=(u<<1)^(u>>8);
  }
  
  return ret;
}

char getchar() {
  char c;
  while (!RI)
    ;
  RI=0;
  c=SBUF;
  return c;
}

char putchar(char c) {
  while (!TI)
    ;
  TI=0;
  SBUF=c;
  if (c=='\n') {
    putchar('\r');
  }
}

int dbg_print(char *s)
{
  while (*s){
    putchar(*(s++));
  }
  return 0;
}


void test_msg1(void)
{
  xdata uchar uc;
  int i;

  msginfo.dadr=2;
  msginfo.cmd=16;
  msginfo.flg=UL_BFL_SND | UL_BFL_ARQ;
  if(ul_newmsg(ul_fd,&msginfo)<0){
    printf("ul_newmsg failed\n");
    return;
  }
  for(i=0;i<23-7;i++){
    uc=i;
    if(ul_write(ul_fd,&uc,1)!=1)
      printf("ul_write failed\n");

  }
  if(ul_freemsg(ul_fd)<0)
    printf("ul_freemsg failed\n");
}

int main()
{
  xdata uchar uc;
  bit send_fl;
  char c;
  int i;
  int loop_cnt1;
  int led_delay;
  LED1=0;
  IE=0; 	/* Disable all interrupts sources */
  ser0_init();

  CKCON&=~7;	/* Fast XDATA access */
  MCON|=1;	/* RAMMAP=1 => Internal RAM 0x8400 - 0x87ff */
  dbg_print("\n\rULAD21 v0.1\n\r");
  dbg_print("RAM test .. ");
  i=xdata_test(0x8400,0x8800);
  if(!i) dbg_print("OK\r\n");
  else if(i==-2) dbg_print("XDATA error\r\n");
  else if(i==-3) dbg_print("XDATA<>CODE error\r\n");
  else dbg_print("unknown error\r\n");

  dbg_print("Ext XRAM test .. ");
  i=xdata_test(0x8800,0xf800);
  if(!i) dbg_print("OK\r\n");
  else if(i==-2) dbg_print("XDATA error\r\n");
  else if(i==-3) dbg_print("XDATA<>CODE error\r\n");
  else dbg_print("unknown error\r\n");

  dbg_print("init_ulan\r\n");
  ul_drv_set_adr(5);
  ul_drv_set_bdiv(5);
  ul_drv_init();
  ul_fd=ul_open(NULL, NULL);
  
  LED1=1;
  deb_wait(2000);
  EA=1;		/* Enable interrupts */
  LED1=1;
  deb_wait(2000);
  i=0;
  send_fl=0;
  while(1){
    LED1=!LED1;
    for(loop_cnt1=0;loop_cnt1++<0x7fff;){
      if(RI) break;
      if(RI_1){
        led_delay=4;
        LED1=1;
      }
      if(TI_1){
        led_delay=4;
        LED1=1;
      }
    }
    putchar('.');
    if(led_delay & 0){
      led_delay--;
      if(!led_delay){
        LED1=0;
      }
    }
    if(RI){
      c=getchar();
      if(c>=0x20)
        printf("c'%c'\n",c);
      else
        printf("c%02X\n",c);
      switch(c){
        case 's':
	  msginfo.dadr=2;
	  msginfo.cmd=16;
	  msginfo.flg=UL_BFL_SND | UL_BFL_ARQ;
	  if(ul_newmsg(ul_fd,&msginfo)<0){
	    printf("ul_newmsg failed\n");
	    break;
	  }
	  for(i=0;i<21;i++){
	    uc=i;
	    if(ul_write(ul_fd,&uc,1)!=1)
	      printf("ul_write failed\n");
	    
	  }
          if(ul_freemsg(ul_fd)<0)
	    printf("ul_freemsg failed\n");
	  break;

        case 't':
	  msginfo.dadr=2;
	  msginfo.sadr=0;
	  msginfo.cmd=17;
	  msginfo.flg=UL_BFL_SND | (UL_BFL_ARQ*0);
	  putchar('A');
	  getchar();
	  if(ul_newmsg(ul_fd,&msginfo)<0){
	    printf("ul_newmsg failed\n");
	    break;
	  }
	  putchar('B');
	  getchar();
          if(ul_freemsg(ul_fd)<0)
	    printf("ul_freemsg failed\n");
	  break;
        case 'i':
	  if(ul_inepoll(ul_fd)){
	    printf("INE\n");
	    print_msg(1);
	  }
	  break;
        case 'p':
	  printf("Printf test\n");
	  break;
        case 'r':
	  printf("regtest start\n");
	  regtest();
	  printf("regtest end\n");
	  break;
        case 'f':
	  send_fl=!send_fl;
	  break;
        case 'x':
	  *(volatile char xdata*)0x8800=0xaa;
	  *(volatile char xdata*)0x8801=0x55;
	  *(volatile char xdata*)0x8800;
	  *(volatile char xdata*)0x8801;
	  break;
      }
    }
    if(i++>=2){
      if(send_fl){
	i=0;
	putchar('x');
	test_msg1();
      }
    }
    if(ul_inepoll(ul_fd)){
      putchar('\n');
      if(1){
      print_msg(1);
      }else{
	if(ul_acceptmsg(ul_fd,&msginfo)<0) putchar('F');
	else {
          if(msginfo.len&&(ul_read(ul_fd,&uc,1)<0)) putchar('E');
	  else putchar('r');
	  ul_freemsg(ul_fd);
	}
      }
    }
  }
}

