; Texas Instruments
; Name:	Reg1210.inc
; Revision: 	1.0
; Description: Include file for TI MSC1210 microcontroller
$NOMOD51
$SAVE
$NOLIST
;  BYTE Registers
P0	DATA	080H	;STANDARD 8051
SP	DATA	081H	;STANDARD 8051
DPL	DATA	082H	;STANDARD 8051
DPH	DATA	083H	;STANDARD 8051
DPL1	DATA	084H
DPH1	DATA	085H
DPS	DATA	086H
PCON	DATA	087H	;STANDARD 8051
TCON	DATA	088H	;STANDARD 8051
TMOD	DATA	089H	;STANDARD 8051
TL0	DATA	08AH	;STANDARD 8051
TL1	DATA	08BH	;STANDARD 8051
TH0	DATA	08CH	;STANDARD 8051
TH1	DATA	08DH	;STANDARD 8051
CKCON	DATA	08EH
MWS	DATA	08FH
P1	DATA	090H	;STANDARD 8051
EXIF	DATA	091H
MPAGE	DATA	092H
CADDR	DATA	093H
CDATA	DATA	094H
MCON	DATA	095H
SCON	DATA	098H	;STANDARD 8051
SBUF	DATA	099H	;STANDARD 8051
SPICON	DATA	09AH
SPIDATA	DATA	09BH
SPIRCON	DATA	09CH
SPITCON	DATA	09DH
SPISTRT	DATA	09EH
SPIEND	DATA	09FH
P2	DATA	0A0H	;STANDARD 8051
PWMCON	DATA	0A1H
PWMLOW	DATA	0A2H
PWMHI	DATA	0A3H
PAI	DATA	0A5H
AIE	DATA	0A6H
AISTAT	DATA	0A7H
IE	DATA	0A8H	;STANDARD 8051
BPCON 	DATA 	0A9H
BPL	DATA	0AAH
BPH	DATA	0ABH
P0DDRL	DATA	0ACH
P0DDRH	DATA	0ADH
P1DDRL	DATA	0AEH
P1DDRH	DATA	0AFH
P3	DATA	0B0H	;STANDARD 8051
P2DDRL	DATA	0B1H
P2DDRH	DATA	0B2H
P3DDRL	DATA	0B3H
P3DDRH	DATA	0B4H
IP	DATA	0B8H	;STANDARD 8051
SCON1   DATA	0C0H
SBUF1   DATA	0C1H
EWU	DATA	0C6H
T2CON   DATA	0C8H	;8052 REGISTER
RCAP2L  DATA	0CAH	;8052 REGISTER
RCAP2H  DATA	0CBH	;8052 REGISTER
TL2	DATA	0CCH	;8052 REGISTER
TH2	DATA	0CDH	;8052 REGISTER
PSW	DATA	0D0H	;STANDARD 8051
OCL	DATA	0D1H
OCM	DATA	0D2H
OCH	DATA	0D3H
GCL	DATA	0D4H
GCM	DATA	0D5H
GCH	DATA	0D6H
ADMUX	DATA	0D7H
EICON	DATA	0D8H
ADRESL	DATA	0D9H
ADRESM	DATA	0DAH
ADRESH	DATA	0DBH
ADCON0	DATA	0DCH
ADCON1	DATA	0DDH
ADCON2	DATA	0DEH
ADCON3	DATA	0DFH
ACC	DATA	0E0H	;STANDARD 8051
SSCON	DATA	0E1H
SUMR0	DATA	0E2H
SUMR1	DATA	0E3H
SUMR2	DATA	0E4H
SUMR3	DATA	0E5H
ODAC	DATA	0E6H
LVDCON	DATA	0E7H
EIE	DATA	0E8H
HWPCO	DATA	0E9H
HWPC1	DATA	0EAH
HWID	DATA	0EBH
;RSRVD	DATA	0ECH
;RSVRD	DATA	0EDH
FMCON	DATA	0EEH
FTCON	DATA	0EFH
B	DATA	0F0H	;STANDARD 8051
PDCON	DATA	0F1H
PASEL	DATA	0F2H
;RSRVD	DATA	0F3H
;RSRVD	DATA	0F4H
ACLK	DATA	0F6H
SRST	DATA	0F7H
EIP	DATA	0F8H
SECINT	DATA	0F9H
MSINT	DATA	0FAH
USEC	DATA	0FBH
MSECL	DATA	0FCH
MSECH	DATA	0FDH
HMSEC	DATA	0FEH
WDTCON	DATA	0FFH


;  BIT Registers
; *** TCON (088H) ***
TF1	BIT	08FH
TR1	BIT	08EH
TF0	BIT	08DH
TR0	BIT	08CH
IE1	BIT	08BH
IT1	BIT	08AH
IE0	BIT	089H
IT0	BIT	088H

; *** P1 (090H) ***
INT5	BIT	097H
INT4	BIT	096H
INT3	BIT	095H
INT2	BIT	094H
TXD1	BIT	093H
RXD1	BIT	092H
T2EX	BIT	091H
T2	BIT	090H

; *** SCON (098H) ***
SM0	BIT	09FH
SM1	BIT	09EH
SM2	BIT	09DH
REN	BIT	09CH
TB8	BIT	09BH
RB8	BIT	09AH
TI	BIT	099H
RI	BIT	098H

; *** IE (0A8H) ***
EA	BIT	0AFH
ES1	BIT	0AEH
ET2	BIT	0ADH
ES	BIT	0ACH
ET1	BIT	0ABH
EX1	BIT	0AAH
ET0	BIT	0A9H
EX0	BIT	0A8H

; *** P3 (0B0H) ***
RD	BIT	0B7H
WR	BIT	0B6H
T1	BIT	0B5H
T0	BIT	0B4H
INT1	BIT	0B3H
INT0	BIT	0B2H
TXD0	BIT	0B1H
RXD0	BIT	0B0H

; *** IP (0B8H) ***
PS1	BIT	0BEH
PT2	BIT	0BDH
PS	BIT	0BCH
PT1	BIT	0BBH
PX1	BIT	0BAH
PT0	BIT	0B9H
PX0	BIT	0B8H

; *** SCON1 (0C0H) ***
SM01	BIT	0C7H
SM11	BIT	0C6H
SM21	BIT	0C5H
REN1	BIT	0C4H
TB81	BIT	0C3H
RB81	BIT	0C2H
TI1	BIT	0C1H
RI1	BIT	0C0H

; *** T2CON (0C8H) ***
TF2	BIT	0CFH
EXF2	BIT	0CEH
RCLK	BIT	0CDH
TCLK	BIT	0CCH
EXEN2	BIT	0CBH
TR2	BIT	0CAH
C_T2	BIT	0C9H
CP_RL2	BIT	0C8H

; *** PSW (0D0H) ***
CY	BIT	0D7H
AC	BIT	0D6H
F0	BIT	0D5H
RS1	BIT	0D4H
RS0	BIT	0D3H
OV	BIT	0D2H
F1	BIT	0D1H
P	BIT	0D0H

; *** EICON (0D8H) ***
SMOD1	BIT	0DFH
EAI	BIT	0DDH
AI	BIT	0DCH
WDTI	BIT	0DBH

; *** EIE (0E8H) ***
EWDI	BIT	0ECH
EX5	BIT	0EBH
EX4	BIT	0EAH
EX3	BIT	0E9H
EX2	BIT	0E8H

; *** EIP (0F8H) ***
PWDI	BIT	0FCH
PX5	BIT	0FBH
PX4	BIT	0FAH
PX3	BIT	0F9H
PX2	BIT	0F8H

; *** Reg ***
Reg0	Data	00H
Reg1	Data	01H
Reg2	Data	02H
Reg3	Data	03H
Reg4	Data	04H
Reg5	Data	05H
Reg6	Data	06H
Reg7	Data	07H
RegB	Data	0F0H
$RESTORE
